// @doc FOINFOINI
// $Id: FoinfoIni.cpp 1.3 2000/11/17 08:19:50EST sfmckay Exp  $
// @module FoinfoIni.cpp |
//
// Functions to handle field office information in an ini file.

#include "stdafx.h"
#include "FoinfoIni.h"

const char *FieldOfficeInfoIni::section = "Field Office Info";
const char *FieldOfficeInfoIni::name = "Name";
const char *FieldOfficeInfoIni::title = "Title";
const char *FieldOfficeInfoIni::address1 = "Address1";
const char *FieldOfficeInfoIni::address2 = "Address2";
const char *FieldOfficeInfoIni::address3 = "Address3";
const char *FieldOfficeInfoIni::address4 = "Address4";

// @mfunc Initializes field office info.

FieldOfficeInfoIni::FieldOfficeInfoIni() : FieldOfficeInfo()
{ }

// @mfunc Reads field office info from ini file.

void FieldOfficeInfoIni::read()
{
   foname = AfxGetApp()->GetProfileString(section, name, "");
   fotitle = AfxGetApp()->GetProfileString(section, title, "");
   foaddr[0] = AfxGetApp()->GetProfileString(section, address1, "");
   foaddr[1] = AfxGetApp()->GetProfileString(section, address2, "");
   foaddr[2] = AfxGetApp()->GetProfileString(section, address3, "");
   foaddr[3] = AfxGetApp()->GetProfileString(section, address4, "");
}

// @mfunc Saves field office info to ini file.

void FieldOfficeInfoIni::write()
{
   if (savename)
      AfxGetApp()->WriteProfileString(section, name, foname.c_str());
   if (savetitle)
      AfxGetApp()->WriteProfileString(section, title, fotitle.c_str());
   if (saveaddress1)
      AfxGetApp()->WriteProfileString(section, address1, foaddr[0].c_str());
   if (saveaddress2)
      AfxGetApp()->WriteProfileString(section, address2, foaddr[1].c_str());
   if (saveaddress3)
      AfxGetApp()->WriteProfileString(section, address3, foaddr[2].c_str());
   if (saveaddress4)
      AfxGetApp()->WriteProfileString(section, address4, foaddr[3].c_str());
}

// @mfunc Dummy function for ini version.

void FieldOfficeInfoIni::setData()
{ }
