//  %W%  %G%
//  Declarations needed for OutDC class

#ifndef __OUTDC_H
#define __OUTDC_H

#include "outfile.h"

class OutDC80 : public Out80
{
   private:
      int ht;  // height of one line in pixels
      int y;  // number of vertical pixels from top of page
      int x;  // number of horizontal pixels from left side of page
      CDC* pDC;  // pointer to device context
   public:
      OutDC80();
      void advanceLine();
      void formfeed();
      void printLine( const std::string& temp );
      void printLine( const char* string );
      void printLinena( const std::string& temp );
      void printLinena( const char* string );
      void setDC( CDC* newDC );
      void setHeight( int newht );
      void setx( int newx );
      void sety( int newy );
};

// Advances one line
inline void OutDC80::advanceLine()
   { y += ht; }
         
// Sets device context to use
inline void OutDC80::setDC( CDC* newDC )
   { pDC = newDC; }

// Sets height of one line
inline void OutDC80::setHeight( int newht )
   { ht = newht; }

// Sets horizontal margin
inline void OutDC80::setx( int newx )
   { x = newx; }

// Sets vertical margin
inline void OutDC80::sety( int newy )
   { y = newy; }
   
// Dummy function
inline void OutDC80::formfeed()
   { }
      
#endif // __OUTDC_H
